// Definition of Datastructure class for UDS/Tiraka homework 2 -


#ifndef DATASTRUCTURE_HH
#define DATASTRUCTURE_HH

#include <vector>
#include <string>
using std::string;

const std::string NOT_AVAILABLE = "Product not in warehouse.";
const std::string NOT_ENOUGH_CANDY = "Not enough candy available.";

class Datastructure
{
    public:

    Datastructure();

    ~Datastructure();

    // Adds candies to the datastructure (command "A")
    void add(const std::string& ID, const std::string& location,
            unsigned int amount, const std::string& name);
          
    // Removes candies from the datastructure (command "D")
    void substract(const std::string& ID, unsigned int amount);

    // Finds candy and prints its status (command "F")
    void find(const std::string& ID) const;

    // Returns how many different types of candy the datastructure contains (command "C")
    size_t count() const;

    // Empties the datastructure (command "E")
    void empty();
    
    // Copy constructor is forbidden (not important for this assignment)
    Datastructure(const Datastructure&) = delete;
    // Assignment operator is forbidden (not important for this assignment)
    Datastructure& operator=(const Datastructure&) = delete;
    
private:
    // Add your own implementation here
    unsigned int laskuri = 0;
    struct varasto {
        std::string hylly;
        unsigned int lkm;
        std::string tuotenimi;
        varasto *seuraava;
        std::string idi;
        int luotu = 0;
    };

    //varasto **taulu;
    //std::vector<varasto*> taulu[50000];
    varasto* taulu[150000];
    bool onko_listassa(const std::string& id);
    void lisaa_valmiiseen(const unsigned int amount, const std::string ID, const std::string &location, const std::string &name);
    unsigned int hashString(const std::string& s) const;
    int maara(int avain);
};

#endif
